using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Web.Services.Protocols;

namespace Demo_10_NorthwindClient
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGridCategories;
		private System.Windows.Forms.Button buttonLoad;
		private System.Windows.Forms.Button buttonSave;

		private MyServices.NorthwindService mNorthwindService = 
			new MyServices.NorthwindService();
		private DataSet mDsCategories;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGridCategories = new System.Windows.Forms.DataGrid();
			this.buttonLoad = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dataGridCategories)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGridCategories
			// 
			this.dataGridCategories.DataMember = "";
			this.dataGridCategories.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridCategories.Location = new System.Drawing.Point(16, 16);
			this.dataGridCategories.Name = "dataGridCategories";
			this.dataGridCategories.Size = new System.Drawing.Size(368, 240);
			this.dataGridCategories.TabIndex = 0;
			// 
			// buttonLoad
			// 
			this.buttonLoad.Location = new System.Drawing.Point(16, 272);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.TabIndex = 1;
			this.buttonLoad.Text = "Load";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Location = new System.Drawing.Point(312, 272);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.TabIndex = 2;
			this.buttonSave.Text = "Save";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 309);
			this.Controls.Add(this.buttonSave);
			this.Controls.Add(this.buttonLoad);
			this.Controls.Add(this.dataGridCategories);
			this.Name = "MainForm";
			this.Text = "Northwind Categores";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGridCategories)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			LoadData();
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			SaveData();
		}

		private void LoadData()
		{
			try
			{
				// Load the categories table from the Web service
				mDsCategories = mNorthwindService.GetCategories();

				// Bind the data to the DataGrid control
				dataGridCategories.DataSource = mDsCategories;
				dataGridCategories.DataMember = "Categories";
			}
			catch (SoapException)
			{
				MessageBox.Show(
					"Can not retrive the categories from the server.", "Error");
			}
		}

		private void SaveData()
		{
			try
			{
				DataSet dsCategoriesChanges = mDsCategories.GetChanges();
				if (dsCategoriesChanges != null)
				{
					// Commit the changes to the Web service
					mNorthwindService.UpdateCategories(dsCategoriesChanges);

					MessageBox.Show("Categories updated succesfully.", "Info");
				}
			}
			catch (SoapException)
			{
				MessageBox.Show(
					"Can not update the categories.", "Error");
			}

			// Refresh the categories table
			LoadData();		
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			LoadData();
		}
	}
}
