using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace Demo_11_SessionService
{
	[WebService(Description="Session Web Service",
		 Namespace="http://www.devbg.org/services/session/v1.0")]
	public class SessionService : System.Web.Services.WebService
	{
		public SessionService()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		[WebMethod(Description="Returns the next value of the global application counter.")]
		public int GetApplicationCounter()
		{
			Application.Lock();
			try
			{
				int counter = 0;
				if (Application["counter"] != null)
				{
					counter = (int) Application["counter"];
				}
				counter++;
				Application["counter"] = counter;
				return counter;
			}
			finally
			{
				Application.UnLock();
			}
		}

		[WebMethod(EnableSession=true, Description="Returns the next value of the local session counter.")]
		public int GetSessionCounter()
		{
			int counter = 0;
			if (Session["counter"] != null)
			{
				counter = (int) Session["counter"];
			}
			counter++;
			Session["counter"] = counter;
			return counter;
		}
	}
}
