using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Web.Services.Protocols;

namespace Demo_14_SecuredService_Client
{
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBoxUserName;
		private System.Windows.Forms.Label labelUserName;
		private System.Windows.Forms.Button buttonLogin;
		private System.Windows.Forms.Label labelPassword;
		private System.Windows.Forms.TextBox textBoxPassword;
		private System.Windows.Forms.Button buttonLogout;
		private System.Windows.Forms.Button buttonGetNotProtectedData;
		private System.Windows.Forms.Button buttonGetProtectedData;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private Services.SecuredService mSecuredService;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxUserName = new System.Windows.Forms.TextBox();
			this.labelUserName = new System.Windows.Forms.Label();
			this.buttonLogin = new System.Windows.Forms.Button();
			this.labelPassword = new System.Windows.Forms.Label();
			this.textBoxPassword = new System.Windows.Forms.TextBox();
			this.buttonLogout = new System.Windows.Forms.Button();
			this.buttonGetNotProtectedData = new System.Windows.Forms.Button();
			this.buttonGetProtectedData = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textBoxUserName
			// 
			this.textBoxUserName.Location = new System.Drawing.Point(72, 8);
			this.textBoxUserName.MaxLength = 50;
			this.textBoxUserName.Name = "textBoxUserName";
			this.textBoxUserName.TabIndex = 0;
			this.textBoxUserName.Text = "";
			// 
			// labelUserName
			// 
			this.labelUserName.AutoSize = true;
			this.labelUserName.Location = new System.Drawing.Point(8, 11);
			this.labelUserName.Name = "labelUserName";
			this.labelUserName.Size = new System.Drawing.Size(63, 16);
			this.labelUserName.TabIndex = 1;
			this.labelUserName.Text = "User name:";
			// 
			// buttonLogin
			// 
			this.buttonLogin.Location = new System.Drawing.Point(184, 9);
			this.buttonLogin.Name = "buttonLogin";
			this.buttonLogin.Size = new System.Drawing.Size(72, 52);
			this.buttonLogin.TabIndex = 2;
			this.buttonLogin.Text = "Login";
			this.buttonLogin.Click += new System.EventHandler(this.buttonLogin_Click);
			// 
			// labelPassword
			// 
			this.labelPassword.AutoSize = true;
			this.labelPassword.Location = new System.Drawing.Point(8, 42);
			this.labelPassword.Name = "labelPassword";
			this.labelPassword.Size = new System.Drawing.Size(57, 16);
			this.labelPassword.TabIndex = 4;
			this.labelPassword.Text = "Password:";
			// 
			// textBoxPassword
			// 
			this.textBoxPassword.Location = new System.Drawing.Point(72, 40);
			this.textBoxPassword.MaxLength = 50;
			this.textBoxPassword.Name = "textBoxPassword";
			this.textBoxPassword.PasswordChar = '*';
			this.textBoxPassword.TabIndex = 3;
			this.textBoxPassword.Text = "";
			// 
			// buttonLogout
			// 
			this.buttonLogout.Location = new System.Drawing.Point(272, 8);
			this.buttonLogout.Name = "buttonLogout";
			this.buttonLogout.Size = new System.Drawing.Size(72, 52);
			this.buttonLogout.TabIndex = 5;
			this.buttonLogout.Text = "Logout";
			this.buttonLogout.Click += new System.EventHandler(this.buttonLogout_Click);
			// 
			// buttonGetNotProtectedData
			// 
			this.buttonGetNotProtectedData.Location = new System.Drawing.Point(16, 80);
			this.buttonGetNotProtectedData.Name = "buttonGetNotProtectedData";
			this.buttonGetNotProtectedData.Size = new System.Drawing.Size(152, 32);
			this.buttonGetNotProtectedData.TabIndex = 6;
			this.buttonGetNotProtectedData.Text = "Get Not Protected Data";
			this.buttonGetNotProtectedData.Click += new System.EventHandler(this.buttonGetNotProtectedData_Click);
			// 
			// buttonGetProtectedData
			// 
			this.buttonGetProtectedData.Location = new System.Drawing.Point(184, 80);
			this.buttonGetProtectedData.Name = "buttonGetProtectedData";
			this.buttonGetProtectedData.Size = new System.Drawing.Size(152, 32);
			this.buttonGetProtectedData.TabIndex = 7;
			this.buttonGetProtectedData.Text = "Get Protected Data";
			this.buttonGetProtectedData.Click += new System.EventHandler(this.buttonGetProtectedData_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(352, 125);
			this.Controls.Add(this.buttonGetProtectedData);
			this.Controls.Add(this.buttonGetNotProtectedData);
			this.Controls.Add(this.buttonLogout);
			this.Controls.Add(this.labelPassword);
			this.Controls.Add(this.textBoxPassword);
			this.Controls.Add(this.buttonLogin);
			this.Controls.Add(this.labelUserName);
			this.Controls.Add(this.textBoxUserName);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Test Secured Web Service";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Instantiate the Web Service proxy class
			mSecuredService = new Services.SecuredService();
			mSecuredService.CookieContainer = new System.Net.CookieContainer();
		}

		private void buttonLogin_Click(object sender, System.EventArgs e)
		{
			string user = textBoxUserName.Text;
			string pass = textBoxPassword.Text;
			try
			{
				mSecuredService.Login(user, pass);
				MessageBox.Show("Login successfull.", "Info");
			}
			catch (SoapException se)
			{
				MessageBox.Show(se.Message, "Error");
			}
		}

		private void buttonLogout_Click(object sender, System.EventArgs e)
		{
			mSecuredService.Logout();
			MessageBox.Show("Logout successfull.", "Info");
		}

		private void buttonGetNotProtectedData_Click(object sender, System.EventArgs e)
		{
			string data = mSecuredService.GetNotProtectedData();
			MessageBox.Show(data, "Info");
		}

		private void buttonGetProtectedData_Click(object sender, System.EventArgs e)
		{
			try
			{
				string data = mSecuredService.GetProtectedData();
				MessageBox.Show(data, "Info");
			}
			catch (SoapException se)
			{
				MessageBox.Show(se.Message, "Error");
			}
		}
	}
}
